/*
Windows memory forensic tookit version 0.1
emodwin v.0.1
Author: Mariusz Burdach
Website: http://forensic.seccure.net
Last update: 02-07-2005


Instruction:
1. set the proper value of PSLOADEDMODULELIST
2. set the proper value of OFFSETW
3. set the path to the physical image file (value of MEM_IMAGE)
4. compile this source file gcc -o emodwin emodwin.c
*/

#include "lib.h"
#include <stdio.h>
#define MEM_IMAGE "../imagew2k3"
#define PSLOADEDMODULELIST 0x00568c08
#define KERNELSPACE 0x80000000
#define OFFSETW 0x00400000  /*Image offset on Windows 2003 Standard Edition without SP. Hints about finding this special offset can be found in paper "an introduction to Windows memory forenisc" */

int calcblk(address)
	unsigned int address;
{
int phadd;

phadd = address - KERNELSPACE + OFFSETW;

return phadd;
}

int main(int argc, char *argv[])
 	{
	FILE *fd;
	struct mod_list doublelinks;  //recalculated addresses

	//Open image file
	fd = fopen(MEM_IMAGE,"r");
	fseek(fd,0,SEEK_SET);


	//read PsLoadedModuleList
	fseek(fd,(PSLOADEDMODULELIST),SEEK_SET);
	fread(&modules,sizeof(struct mod_list),1,fd);

		//print the list 
		printf("Loaded Module List - emodwin 0.1\n");

	unsigned int tempadd = calcblk(modules.next);
	unsigned int prev = calcblk(modules.prev);
	unsigned int next = 0;
	unsigned int chartable=0;
	unsigned int real_charadd = 0;
	unsigned int mapped =0;

printf("Physical address | Name\n");
printf("+++++++++++++++++++++++++++++++++++++++\n");

while (prev != next){
	
	fseek(fd,(tempadd),SEEK_SET);
	fread(&doublelinks,sizeof(struct mod_list),1,fd);
	next=calcblk(doublelinks.next);
	
	fseek(fd,(tempadd)+0x18,SEEK_SET);
	fread(&mapped,sizeof(unsigned int),1,fd);

	fseek(fd,(tempadd)+0x30,SEEK_SET);
	fread(&chartable,sizeof(unsigned int),1,fd);
	real_charadd = calcblk(chartable);
	fseek(fd,(real_charadd),SEEK_SET);
	
	//reading file names stored in UNICODE	
        char ch;
	int count=0;
	printf(" 0x%x ",tempadd);
        printf("      ");
                while(((ch=getc(fd)) != 0x2e)){
                putc(ch,stdout);
                }
	putc(ch,stdout);
	
			while(count != 6){
			ch=getc(fd);
			putc(ch,stdout);
			count++;
			}
	count = 0;
	tempadd=next;
	printf("\n");

	}//end of loop
	//last entry
	fseek(fd,(tempadd)+0x18,SEEK_SET);
	fread(&mapped,sizeof(unsigned int),1,fd);

	fseek(fd,(tempadd)+0x30,SEEK_SET);
	fread(&chartable,sizeof(unsigned int),1,fd);
	real_charadd=calcblk(chartable);
	fseek(fd,(real_charadd),SEEK_SET);

	char ch2;
	printf(" 0x%x ",tempadd);
	printf("      ");
		while(((ch2=getc(fd)) != 0x2e)){
		putc(ch2,stdout);
		}
	putc(ch2,stdout);
	int count=0;
			while(count !=6){
			ch2=getc(fd);
			putc(ch2,stdout);
			count++;
			}
	printf("\n");	
	//end of last entry

	return 0;
	}
