/* 
Windows memory forensic toolkit version 0.1
eprocwin v.0.1
Author: Mariusz Burdach
Website: http://forensic.seecure.net
Last Update: 01-07-2005

Instruction:
1. set the proper value of PSACTIVEPROCESSHEAD
2. set the proper value of OFFSETW
3. set the path to the physical image file (value of MEM_IMAGE)
4. compile this source file gcc -o eprocwin eprocwin.c

*/

#include "lib.h"
#include <stdio.h>
#define MEM_IMAGE "../imagew2k3"
#define _EPROCESS 0x01baa678
#define PSACTIVEPROCESSHEAD 0x0056ede8
#define KERNELSPACE 0x80000000
#define OFFSETW 0x00400000  /*Image offset on Windows 2003 Standard Edition without SP. Hints about finding this special offset can be found in paper */

int calcblk(address)
	unsigned int address;
{
int phadd;

phadd = address - KERNELSPACE + OFFSETW - 0x88;

return phadd;
}

int main(int argc, char* argv[])
 	{
	FILE *fd;
	const char* imagename = NULL;
	struct task_list doublelinks;  //recalculated addresses of _EPROCESS
	int eprocblk=0;  //licznik procesow
	unsigned int eprocblk_start = 0; //adres poczatku bloku
	unsigned int last_eprocblk_start = 0;//last _EPROCESS block
	unsigned int last_eprocblk_start2 = 0; //last _EPROCESS block in loop

	//temp solution :(
	imagename = argv[1];

	//Open image file
	fd = fopen(MEM_IMAGE,"r");
	fseek(fd,0,SEEK_SET);

	//find the beginning of the _EPROCESS block
	fseek(fd,(_EPROCESS)+0x84,SEEK_SET);

	//read ActiveProcessLinks
	fseek(fd,(PSACTIVEPROCESSHEAD),SEEK_SET);
	fread(&tasks,sizeof(struct task_list),1,fd);

		//print the content of tasks
		printf("_EPROCESS extractor - eprocwin 0.1\n");

		int testowy;
		testowy = calcblk(tasks.next);
		eprocblk_start = testowy;

		//Description
		printf("Process ID  Process name\n");
		printf("++++++++++++++++++++++++++++++++++++\n");
	
/*Enumerating the _EPROCESS blocks from memory images.
*/
while (tasks.prev != last_eprocblk_start2) 
{
	//Process CID
	fseek(fd,(eprocblk_start)+0x84,SEEK_SET);
	int eprocess_block_cid;
	fread(&eprocess_block_cid,sizeof(int),1,fd);

 	printf("CID [%.5d] ",eprocess_block_cid);

	//the name of an image of a current process
	char ch;
	fseek(fd,(eprocblk_start)+0x154,SEEK_SET);
	printf("Image name: ");
                while((ch=getc(fd)) != '\0'){
                putc(ch,stdout);
                }
	//read next block
	fseek(fd,(eprocblk_start)+0x88,SEEK_SET);
        fread(&last_eprocblk_start2,sizeof(int),1,fd);

	//calculate new eprocess block
	eprocblk_start = calcblk(last_eprocblk_start2);
	eprocblk++;//count++
	printf("\n");//new line
};
//End of _EPROCESS block
	/*Last _EPROCESS block (probably tool used to dump this memory image */
	//Process CID
        fseek(fd,(eprocblk_start)+0x84,SEEK_SET);
        int eprocess_block_cid;
        fread(&eprocess_block_cid,sizeof(int),1,fd);

        printf("CID [%.5d] ",eprocess_block_cid);

	//the name of an image of a current process
        char ch;
        fseek(fd,(eprocblk_start)+0x154,SEEK_SET);
        printf("Image name: ");
                while((ch=getc(fd)) != '\0'){
                putc(ch,stdout);
                }
	eprocblk++;
        //end of last _EPROCESS block

	printf("\n Total number of _EPROCESS blocks: %d \n",eprocblk);
	return 0;
	}
