/*
This proof of concept tool detects all files used in the past.

pfenum version 0.1
Last update: 29 03 2005
Author: Mariusz Burdach
Email:  Mariusz.Burdach@seccure.net

Tested on kernels: 2.4.20-8
*/

#include "idetect.h"
#include <getopt.h>
#include <stdio.h>
#include <stdlib.h>
#define KERN 0xc0000000
#define PAGES_NR 16384  //total number of page frames in node
#define MEMMAP 0xc1000030  //the address of the global mem_map array
#define MEMIMG "/dev/mem"

const char* pfenum;
void print_usage (FILE* stream, int exit_code)
{
fprintf(stream, "Usage: %s options \n", pfenum);
fprintf(stream,
" -h --help Display this usage information\n"
" -a --all Display files used in the past\n");
exit (exit_code);
}

int main(int argc, char *argv[]){
	FILE *fd;
	int i,pid,add;
	struct doublelink initial;
	struct task_temp task;
	struct vma_temp vmas;
	Elf32_Ehdr filehead;
	Elf32_Phdr proghead;
	int kernoff,ch;
	int next_option;
	
	const char* const short_options = "h:a";
	const struct option long_options[] = {
	{ "help", 0, NULL, 'h' },
	{ "all", 0, NULL, 'a' },
	{ NULL, 0, NULL, 0 } 
	};
	const char* process = NULL;
	pfenum = argv[0];
	do {
		next_option = getopt_long (argc, argv, short_options,
	long_options, NULL);
	switch (next_option)
	{
	case 'h': /* -h or --help */
	print_usage (stdout, 0);
	case 'a': /* -a or --all */
	//read file and file head
		fd=fopen(MEMIMG,"r");
		fseek(fd,0,SEEK_SET);
	/*
		fread(&filehead,sizeof(Elf32_Ehdr),1,fd);
		//read prog head and offset to kernel area
			for(i=0;i<filehead.e_phnum;i++){
			fseek(fd,filehead.e_phoff+(i*filehead.e_phentsize),SEEK_SET);
			fread(&proghead,filehead.e_phentsize,1,fd);
				if(proghead.p_vaddr == KERN){
				kernoff=proghead.p_offset;
				break;
				}
			}
	*/
	kernoff=0x0;
	struct mypage pagex;
	unsigned int vma;
//take init and process tasks
	int licz3;
	unsigned int count1;
	unsigned int mm_str;
	for(licz3=0;licz3<PAGES_NR;licz3++){
		fseek(fd,(MEMMAP+kernoff-KERN)+licz3*sizeof(struct mypage),SEEK_SET);
		fread(&pagex,sizeof(struct mypage),1,fd);
		fseek(fd,(pagex.mapping+kernoff-KERN)+9*sizeof(unsigned int),SEEK_SET);
		fread(&vma,sizeof(unsigned int),1,fd);
		if(vma == 0){
			unsigned int inode=0;
			unsigned int atime=0;
			unsigned int dir=0;
			int czas;
			fseek(fd,(pagex.mapping+kernoff-KERN)+8*sizeof(unsigned int),SEEK_SET);
			fread(&inode,sizeof(unsigned int),1,fd);
			fseek(fd,(inode+kernoff-KERN)+19*sizeof(unsigned int),SEEK_SET);
			fread(&atime,sizeof(unsigned int),1,fd);
			fseek(fd,(inode+kernoff-KERN)+4*sizeof(unsigned int),SEEK_SET);
			fread(&dir,sizeof(unsigned int),1,fd);
			fseek(fd,(dir+kernoff-KERN)+12*sizeof(unsigned int),SEEK_SET);
			int licznik=0;
			printf(" ");
				while(((ch = getc(fd)) != '\0') && licznik < 12){
				putc(ch,stdout);
				licznik++;
				}
	
			printf(" <-- vma = 0 [released] atime: %d ",atime);

		}

		fseek(fd,(pagex.mapping+kernoff-KERN)+6*sizeof(unsigned int),SEEK_SET);
		count1=0;
		fread(&count1,sizeof(unsigned int),1,fd);
		fseek(fd,vma+kernoff-KERN,SEEK_SET);
		mm_str=0;
		fread(&mm_str,sizeof(unsigned int),1,fd);
		printf("This page frame nr: %d pointed by mapping at: %x -> vma: %x mm_struct: %x phaddress: %x total nr of pf: %x\n",licz3,pagex.mapping,vma,mm_str,pagex.virtuall,count1);
	}

	break;
//===========
case '?': 
print_usage (stderr, 1);
case -1: 
break;
default:
abort ();
}
}
while (next_option != -1);
	return 0;
}
