/*
This proof of concept tool enumerates all User Mode processes.
Please keep in mind that Kernel threads are omitted.

procenum version 0.1
date: 29 03 2005
Author: Mariusz Burdach 
Email:  Mariusz.Burdach@seccure.net

Tested on kernels: 2.4.20-8
Before compilation: It is necessary to set proper value of PAGES_NR
Compilation: gcc -o procenum procenum.c

Options:
-v Verbose
-a shows all user-mode processes
-h help

*/
#include "idetect.h"
#include <getopt.h>
#include <stdio.h>
#include <stdlib.h>
#define KERN 0xc0000000
#define PAGES_NR 16384//12288 // 28672 //provide the number of page frames in node (ZONE_DMA, ZONE_NORMAL and ZONE_HIGHMEM)
#define MEMMAP 0xc1000030 //the address of the global mem_map array

struct myids{
        unsigned int tablica;
        char namtab[30];
} ids[100];

char nametab[30];

//struct myids ids;
	int y;
	int stan_tablicy=0;
	int add_entry(unsigned int add_mm, char tab_name[30])
	{
		ids[stan_tablicy].tablica=add_mm;
		strcpy(ids[stan_tablicy].namtab,tab_name);
		stan_tablicy++;
		//	printf("ADDED!!! %x",ids[stan_tablicy-1].tablica);
	return 0;
	}

const char* procenum;
void print_usage (FILE* stream, int exit_code)
{
fprintf(stream, "Usage: %s options [ number... ]\n", procenum);
fprintf(stream,
" -h --help Display this usage information\n"
" -a --all Display all User Mode processes\n"
" -v --verbose Display detailed information about all page frames\n");
exit (exit_code);
}

int main(int argc, char *argv[]){
	
        FILE *fd;
        int i,pid,add;
        struct doublelink initial;
        struct task_temp task;
        struct vma_temp vmas;
        Elf32_Ehdr filehead;
        Elf32_Phdr proghead;
        int kernoff,ch;
	struct mypage pagex;
	unsigned int vma;
	int licz3;
	unsigned int count1;
	unsigned int mm_str;
	unsigned int flagi;
	unsigned int inode;
	unsigned int atime;
	unsigned int dir;
	unsigned int page_desc;
	int xxxx;


	int next_option;
	const char* const short_options = "h:va";
	const struct option long_options[] = {
		{ "help", 0, NULL, 'h' },
		{ "all", 0, NULL, 'a' },
		{ "verbose", 0, NULL, 'v' },
		{ NULL, 0, NULL, 0 }
	};
	const char* verbose = NULL;
	procenum = argv[0];
	do {
		next_option = getopt_long (argc, argv, short_options,
		long_options, NULL);
	switch (next_option)
	{
	case 'h': /* -h or --help */
		print_usage (stdout, 0);
	case 'a': /* -a or --all */

	fd=fopen("/dev/mem","r");
        fseek(fd,0,SEEK_SET);

/*        fread(&filehead,sizeof(Elf32_Ehdr),1,fd);
	//read prog head and offset to kernel area
                for(i=0;i<filehead.e_phnum;i++){
                        fseek(fd,filehead.e_phoff+(i*filehead.e_phentsize),SEEK_SET);
                        fread(&proghead,filehead.e_phentsize,1,fd);
                                if(proghead.p_vaddr == KERN){
                                kernoff=proghead.p_offset;
                                break;
                                }
                }
*/
	kernoff=0x0;
        for(y=0;y<=100;y++){
                 ids[y].tablica=0;
                   }


        for(licz3=0;licz3<=PAGES_NR;licz3++)
        {
                fseek(fd,(MEMMAP+kernoff-KERN)+licz3*sizeof(struct mypage),SEEK_SET);
                page_desc=MEMMAP+licz3*sizeof(struct mypage);
                pagex.mapping=0;
                fread(&pagex,sizeof(struct mypage),1,fd);               //read page descriptor
                fseek(fd,(pagex.mapping+kernoff-KERN)+9*sizeof(unsigned int),SEEK_SET); //address address_space
                        if((pagex.mapping == 0) || (pagex.list_next == page_desc))
                                {
                                //printf("Page never used --> ");
                                }
                        else
                {

                vma=0;
                fread(&vma,sizeof(unsigned int),1,fd);
                fseek(fd,(vma+kernoff-KERN),SEEK_SET);
                mm_str=0;
                fread(&mm_str,sizeof(unsigned int),1,fd); //czytamy mm_sdtruct
                fseek(fd,mm_str+kernoff-KERN,SEEK_SET);
                vma=0;
                fread(&vma,sizeof(unsigned int),1,fd);
                unsigned int linia;
                fseek(fd,(vma+kernoff-KERN)+1*sizeof(unsigned int),SEEK_SET);
                linia=0;
                fread(&linia,sizeof(unsigned int),1,fd);

                if((vma != 0))// && ( linia == 0x08048000))
                        {
                                inode=0;
                                atime=0;
                                dir=0;
                                fseek(fd,(vma+kernoff-KERN)+5*sizeof(unsigned int),SEEK_SET);
                                flagi=0;
                                fread(&flagi,sizeof(unsigned int),1,fd);
                                fseek(fd,(vma+kernoff-KERN)+14*(sizeof(unsigned int)),SEEK_SET);
                                unsigned int file_descript;
                                file_descript=0;
                                fread(&file_descript,sizeof(unsigned int),1,fd);
                                fseek(fd,(file_descript+kernoff-KERN)+2*(sizeof(unsigned int)),SEEK_SET);
                                dir=0;
                                fread(&dir,sizeof(unsigned int),1,fd);                  //adres dirent
                                fseek(fd,(dir+kernoff-KERN)+24*sizeof(unsigned int),SEEK_SET);
                                        int licznik=0;
                                        nametab[licznik]='\0';
                                                while(((ch = getc(fd)) != '\0') && licznik < 19){
                                                nametab[licznik] = ch;
                                                licznik++;
                                                }
                                                nametab[licznik] = '\0';


                fseek(fd,(pagex.mapping+kernoff-KERN)+6*sizeof(unsigned int),SEEK_SET); //pobieramy liczbe stron
                fread(&count1,sizeof(unsigned int),1,fd);
                //if(vma!= NULL){
                fseek(fd,vma+kernoff-KERN,SEEK_SET);
                mm_str=0;
              	fread(&mm_str,sizeof(unsigned int),1,fd); //czytamy mm_sdtruct
                int u=0;
                if((mm_str != 0) && (nametab[0] != '\0') && (pagex.list_next != 0))
                {
                        while(u<=99)
                                {
                                if(ids[u].tablica == mm_str){
                                        //printf("jest wpis");
                                        break;
                                        }
                                //else
                                if((ids[u].tablica != mm_str) && (u == 99))// && ((flagi & 0x1000) >0))
                                {
                                        add_entry(mm_str,nametab);
                                        //printf("tutaj spelnione sa warrunki (page_no0) tablica[%x] i u=%d!!!",ids[u].tablica,u);
                                        break;
                                }
                                u++;
                                }
                }
               if((mm_str != 0) && (pagex.list_next == 0 ))//(nametab[0] != '\0') && (pagex.list_next == NULL))
                {//if dotyczy stron swap tag:xxx8

                        mm_str=pagex.mapping;
                        fseek(fd,(mm_str+kernoff-KERN),SEEK_SET);
                        vma=0;
                        fread(&vma,sizeof(unsigned int),1,fd);

                fseek(fd,((vma+kernoff-KERN)+14*sizeof(unsigned int)),SEEK_SET);
                unsigned int file_str;
                file_str=0;
                fread(&file_str,sizeof(unsigned int),1,fd);
                fseek(fd,(file_str+kernoff-KERN)+2*sizeof(unsigned int),SEEK_SET);
                dir=0;
                fread(&dir,sizeof(unsigned int),1,fd);                  //adres dirent
                fseek(fd,(dir+kernoff-KERN)+24*sizeof(unsigned int),SEEK_SET);
                 int licznik=0;
                 nametab[licznik]='\0';
                                while(((ch = getc(fd)) != '\0') && licznik < 19){
                                nametab[licznik] = ch;
                                licznik++;
                             }
                  nametab[licznik] = '\0';

                                while(u<=99)
                                { //poczatek while
                                if(ids[u].tablica == mm_str){
                                        //printf("jest wpis");
                                        break;
                                        }
                                //else
                                if((ids[u].tablica != mm_str) && (u == 99))// && ((flagi & 0x1000) >0))
                                {
                                        add_entry(mm_str,nametab);
                                        //printf("SPELNIONE sa warrunki (page 0)tablica[%x] i u=%d!!!",ids[u].tablica,u);
                                        break;
                                }
                                u++;
                                } //koniec while



                }//end of page swap tag: xxx8
                }
       }//end of for loop
	}
               // printf("strona %d\n",licz3);

                for(xxxx=0;xxxx<stan_tablicy;xxxx++)
                {

                        printf("table entry: [%d] name: [%s] mm_struct: [%x]\n",xxxx,ids[xxxx].namtab,ids[xxxx].tablica);
                }
	break;
	//============================================
	case 'v':

	fd=fopen("/dev/mem","r");
        fseek(fd,0,SEEK_SET);

/*        fread(&filehead,sizeof(Elf32_Ehdr),1,fd);
//read prog head and offset to kernel area
                for(i=0;i<filehead.e_phnum;i++){
                        fseek(fd,filehead.e_phoff+(i*filehead.e_phentsize),SEEK_SET);
                        fread(&proghead,filehead.e_phentsize,1,fd);
                                if(proghead.p_vaddr == KERN){
                                kernoff=proghead.p_offset;
                                break;
                                }
                }
*/
	kernoff=0x0;
        for(y=0;y<=100;y++){
                 ids[y].tablica=0;
                   }


        for(licz3=0;licz3<=PAGES_NR;licz3++)
        {
                fseek(fd,(MEMMAP+kernoff-KERN)+licz3*sizeof(struct mypage),SEEK_SET);
                page_desc=MEMMAP+licz3*sizeof(struct mypage);
                pagex.mapping=0;
                fread(&pagex,sizeof(struct mypage),1,fd);               //pobierz strone
                fseek(fd,(pagex.mapping+kernoff-KERN)+9*sizeof(unsigned int),SEEK_SET); //adres address_spac
                        if((pagex.mapping == 0) || (pagex.list_next == page_desc))
                                {
                                printf("Page never used --> ");
                                }
                        else
                {

                vma=0;
                fread(&vma,sizeof(unsigned int),1,fd);
                fseek(fd,(vma+kernoff-KERN),SEEK_SET);
                mm_str=0;
                fread(&mm_str,sizeof(unsigned int),1,fd); //czytamy mm_sdtruct
                fseek(fd,mm_str+kernoff-KERN,SEEK_SET);
                vma=0;
                fread(&vma,sizeof(unsigned int),1,fd);
                unsigned int linia;
                fseek(fd,(vma+kernoff-KERN)+1*sizeof(unsigned int),SEEK_SET);
                linia=0;
                fread(&linia,sizeof(unsigned int),1,fd);

                if((vma != 0))// && ( linia == 0x08048000))
                        {
                                inode=0;
                                atime=0;
                                dir=0;
                               fseek(fd,(vma+kernoff-KERN)+5*sizeof(unsigned int),SEEK_SET);
                                flagi=0;
                                fread(&flagi,sizeof(unsigned int),1,fd);
                                fseek(fd,(vma+kernoff-KERN)+14*(sizeof(unsigned int)),SEEK_SET);
                                unsigned int file_descript;
                                file_descript=0;
                                fread(&file_descript,sizeof(unsigned int),1,fd);
                                fseek(fd,(file_descript+kernoff-KERN)+2*(sizeof(unsigned int)),SEEK_SET);
                                dir=0;
                                fread(&dir,sizeof(unsigned int),1,fd);                  //adres dirent
                                fseek(fd,(dir+kernoff-KERN)+24*sizeof(unsigned int),SEEK_SET);
                                        int licznik=0;
                                        nametab[licznik]='\0';
                                                while(((ch = getc(fd)) != '\0') && licznik < 19){
                                                nametab[licznik] = ch;
                                                licznik++;
                                                }
                                                nametab[licznik] = '\0';


                fseek(fd,(pagex.mapping+kernoff-KERN)+6*sizeof(unsigned int),SEEK_SET); //pobieramy liczbe stron
                fread(&count1,sizeof(unsigned int),1,fd);
                //if(vma!= NULL){
                fseek(fd,vma+kernoff-KERN,SEEK_SET);
                mm_str=0;
              fread(&mm_str,sizeof(unsigned int),1,fd); //czytamy mm_sdtruct
                int u=0;
                 if((mm_str != 0) && (nametab[0] != '\0') && (pagex.list_next != 0))
                {
                        while(u<=99)
                                {
                                if(ids[u].tablica == mm_str){
                                        printf("jest wpis");
                                        break;
                                        }
                                //else
                                if((ids[u].tablica != mm_str) && (u == 99))// && ((flagi & 0x1000) >0))
                                {
                                        add_entry(mm_str,nametab);
                                        printf("tutaj spelnione sa warrunki (page_no0) tablica[%x] i u=%d!!!",ids[u].tablica,u);
					printf("\nADDED !!! %x\n",mm_str);
                                        break;
                                }
                                u++;
                                }
                }
               if((mm_str != 0) && (pagex.list_next == 0 ))//(nametab[0] != '\0') && (pagex.list_next == NULL))
                {//if dotyczy stron swap tag:xxx8
                        mm_str=pagex.mapping;
                        fseek(fd,(mm_str+kernoff-KERN),SEEK_SET);
                        vma=0;
                        fread(&vma,sizeof(unsigned int),1,fd);

                fseek(fd,((vma+kernoff-KERN)+14*sizeof(unsigned int)),SEEK_SET);
                unsigned int file_str;
                file_str=0;
                fread(&file_str,sizeof(unsigned int),1,fd);
                fseek(fd,(file_str+kernoff-KERN)+2*sizeof(unsigned int),SEEK_SET);
                dir=0;
                fread(&dir,sizeof(unsigned int),1,fd);                  //adres dirent
                fseek(fd,(dir+kernoff-KERN)+24*sizeof(unsigned int),SEEK_SET);
                 int licznik=0;
                 nametab[licznik]='\0';
                                while(((ch = getc(fd)) != '\0') && licznik < 19){
                                nametab[licznik] = ch;
                                licznik++;
                             }
                  nametab[licznik] = '\0';

                                while(u<=99)
                                { //poczatek while
                                if(ids[u].tablica == mm_str){
                                        printf("jest wpis");
                                        break;
                                        }
                                //else
                                if((ids[u].tablica != mm_str) && (u == 99))// && ((flagi & 0x1000) >0))
                                {
                                        add_entry(mm_str,nametab);
                                        printf("Conditions fulfilled (page 0) table[%x] i u=%d!!!",ids[u].tablica,u);
                                        break;
                                }
                                u++;
                                } //koniec while
                }//koniec stron swap tag: xxx8
               printf("Page [%x] %d belongs to mapping %x -> vma: %x -> mm_struct %x physical address: %x pages count: %x name: %s\n",page_desc,licz3,pagex.mapping,vma,mm_str,pagex.virtuall,count1,nametab);
                }
       }//koniec for
        }
                printf("Page: %d\n",licz3);

                for(xxxx=0;xxxx<stan_tablicy;xxxx++)
                {

                        printf("table entry: [%d] name: [%s] mm_struct: [%x]\n",xxxx,ids[xxxx].namtab,ids[xxxx].tablica);
                }




	break;
	//---------------------------------
	case '?': 
	print_usage (stderr, 1);
	case -1: 
	break;
	default: 
	abort ();
	}
}
while (next_option != -1);

	return 0;
}
