/*
This proof of concept tool enumerates all task_structs from a doubly linked list stored in the tasks field.
All threads with the same mm_struct are printed as separate entry.

taskenum version 0.1
date: 29 03 2005
Author: Mariusz Burdach
Email:   Mariusz.Burdach@seccure.net

This tool was tested on kernels: 2.4.20-8
*/
#include "idetect.h"
#include <getopt.h>
#include <stdio.h>
#include <stdlib.h>
#define KERN 0xc0000000  //PAGE_OFFSET
#define INIT 0xc034c000  //an address of init_task_union. Can be found in System.map.

const char* taskenum;
void print_usage (FILE* stream, int exit_code)
{
fprintf(stream, "Usage: %s options [ number... ]\n", taskenum);
fprintf(stream,
" -h --help Display this usage information\n"
" -a --all Display all active processes\n"
" -p --process Display detailed information about selected process\n");
exit (exit_code);
}

int main(int argc, char *argv[]){

	FILE *fd;
	int i,pid,add;
	struct doublelink initial;
	struct task_temp task;
	struct vma_temp vmas;
	Elf32_Ehdr filehead; //when data are read from /proc/kcore
	Elf32_Phdr proghead; //--||--
	int kernoff,ch;

	int next_option;
	const char* const short_options = "hp:a";
	const struct option long_options[] = {
		{ "help", 0, NULL, 'h' },
		{ "all", 0, NULL, 'a' },
		{ "process", 1,NULL, 'p' },
		{ NULL, 0, NULL, 0 }
	};
	const char* process = NULL;
	taskenum = argv[0];
	do {
		next_option = getopt_long (argc, argv, short_options,
		long_options, NULL);
	switch (next_option)
	{
	case 'h': /* -h or --help */
		print_usage (stdout, 0);
	case 'a': /* -a or --all */
		fd=fopen("/dev/mem","r");
		fseek(fd,0,SEEK_SET);
		/*fread(&filehead,sizeof(Elf32_Ehdr),1,fd);  //If we want to read from /proc/kcore
		//read prog head and offset to kernel area
		for(i=0;i<filehead.e_phnum;i++){
			fseek(fd,filehead.e_phoff+(i*filehead.e_phentsize),SEEK_SET);
			fread(&proghead,filehead.e_phentsize,1,fd);
			if(proghead.p_vaddr == KERN){
		kernoff=proghead.p_offset;
		break;
			}
		}
		*/ 					//end of section related to /proc/kcore
		kernoff=0x0;				//remove it if you want to read from /proc/kcore

//read the init task structure and store tasks (prev and next)
	fseek(fd,(INIT+kernoff-KERN)+(21*sizeof(unsigned int)),SEEK_SET);
	fread(&initial,sizeof(struct doublelink),1,fd);
	fseek(fd,(INIT+kernoff-KERN)+(191*sizeof(int)+0x2),SEEK_SET);
	printf("Process: ");
		while((ch=getc(fd)) != '\0'){
		putc(ch,stdout);
		}
	printf("Attention: first task_struct at %x (this is init) and last at %x",initial.next,initial.prev);
	fseek(fd,(initial.next+kernoff-KERN),SEEK_SET);
	fread(&task,sizeof(struct task_temp),1,fd);

	//Printing all pids and some addresses of related structures
	while(task.prev != initial.prev){
		fseek(fd,(task.next+kernoff-KERN),SEEK_SET);
		fread(&task,sizeof(struct task_temp),1,fd);
		//printf(" next %x i prev %x",task.next,task.prev);
		fseek(fd,(task.next+kernoff-KERN-0x54)+(35*sizeof(unsigned int)),SEEK_SET);
		fread(&pid,sizeof(int),1,fd);
		printf("\nPid: %6d",pid);

		fseek(fd,(task.next+kernoff-KERN-0x54)+(191*sizeof(unsigned int)+0x2),SEEK_SET);
		//Process name
		printf(" [");
			while((ch = getc(fd)) != '\0'){
			putc(ch,stdout);
			}

		printf("] task_struct:[0x%x]",task.next-0x60); //Store task_struct
		fseek(fd,(task.next+kernoff-KERN)+(6*sizeof(unsigned int)),SEEK_SET);
		fread(&add,sizeof(int),1,fd);
		printf(" mm:[0x%x]",add);
	}
        printf("\n");
	break;
	//============================================
	case 'p':
	process = optarg;
	int temp999;
	temp999=atoi(process);
	printf("The process number %d",temp999);
	fd=fopen("/dev/mem","r");
	fseek(fd,0,SEEK_SET);
	/*					//this part is related to reading data from /proc/kcore
	fread(&filehead,sizeof(Elf32_Ehdr),1,fd);
	//read prog head and offset to kernel area
	for(i=0;i<filehead.e_phnum;i++){
		fseek(fd,filehead.e_phoff+(i*filehead.e_phentsize),SEEK_SET);
		fread(&proghead,filehead.e_phentsize,1,fd);
			if(proghead.p_vaddr == KERN){
			kernoff=proghead.p_offset;
			break;
			}
	}
	*/
	kernoff=0x0;		//remove it if you want to read from /proc/kcore

	//take init and process tasks
	fseek(fd,(INIT+kernoff-KERN)+(21*sizeof(unsigned int)),SEEK_SET);
	fread(&initial,sizeof(struct doublelink),1,fd);
	fseek(fd,(INIT+kernoff-KERN)+(191*sizeof(int)+0x2),SEEK_SET);
	fseek(fd,(initial.next+kernoff-KERN),SEEK_SET);
	fread(&task,sizeof(struct task_temp),1,fd);
		while(task.prev != initial.prev){
			fseek(fd,(task.next+kernoff-KERN),SEEK_SET);
			fread(&task,sizeof(struct task_temp),1,fd);
			fseek(fd,(task.next+kernoff-KERN-0x54)+(35*sizeof(unsigned int)),SEEK_SET);
			fread(&pid,sizeof(int),1,fd);

			fseek(fd,(task.next+kernoff-KERN)+(6*sizeof(unsigned int)),SEEK_SET);
			fread(&add,sizeof(int),1,fd);
			if(pid == temp999){
				printf("\nPid: %6d",pid);
				printf(" [");
				fseek(fd,(task.next+kernoff-KERN-0x54)+(191*sizeof(unsigned int)+0x2),SEEK_SET);
					while((ch = getc(fd)) != '\0'){
					putc(ch,stdout);
					}
				printf("] task_struct:[0x%x]",task.next-0x54); //czytamy task_struct
				printf(" mm:[0x%x]",add);


			break;
			}

		}
	fseek(fd,(add+kernoff-KERN),SEEK_SET);

	fread(&vmas,2*(sizeof(unsigned int)),1,fd);
        //  printf("to co dalej %x oraz %x\n",vmas.prev, vmas.next);
	fseek(fd,(add+kernoff-KERN)+(7*sizeof(unsigned int)),SEEK_SET);
	int count0;
	fread(&count0,sizeof(int),1,fd);
	printf("Number of memory regions (vmas): %d\n",count0);
	unsigned int start;
	unsigned int stop;
	unsigned int vma_str;
	unsigned int file;
	unsigned int dir;
	unsigned int inode;
	unsigned int mapping;
	unsigned int page0,page1;
	char name[50];
	int z;
	int atime;
	vma_str=vmas.next;
	for (z=0;z<count0;z++){
		fseek(fd,(vma_str+kernoff-KERN)+sizeof(unsigned int),SEEK_SET);
		fread(&start,sizeof(unsigned int),1,fd);
		fseek(fd,(vma_str+kernoff-KERN)+2*sizeof(unsigned int),SEEK_SET);
                fread(&stop,sizeof(unsigned int),1,fd);

		fseek(fd,(vma_str+kernoff-KERN)+14*sizeof(unsigned int),SEEK_SET);
		fread(&file,sizeof(unsigned int),1,fd);
		//printf("co jest w file %x\n",file);	
		if (file == 0){
			printf("\n\n!!! This VMA is not mapped !!!\n");
			printf(" Address range: %x-%x (vma: %x)\n\n",start,stop,vma_str);
			printf("==============Memory region================\n");

			}
			else {	
			fseek(fd,(file+kernoff-KERN)+2*sizeof(unsigned int),SEEK_SET);
			fread(&dir,sizeof(unsigned int),1,fd);
				fseek(fd,(dir+kernoff-KERN)+24*sizeof(unsigned int),SEEK_SET);	
				int licznik=0;
				while((ch = getc(fd)) != '\0'){
				//putc(ch,stdout);
				name[licznik]=ch;
				licznik++;
				}
				name[licznik]='\0';
				fseek(fd,(dir+kernoff-KERN)+2*sizeof(unsigned int),SEEK_SET);
				fread(&inode,sizeof(unsigned int),1,fd);
			          fseek(fd,(inode+kernoff-KERN)+19*sizeof(unsigned int),SEEK_SET);
				  fread(&atime,sizeof(int),1,fd);
			         // printf("czas %x",atime);
				  fseek(fd,(inode+kernoff-KERN)+41*sizeof(unsigned int),SEEK_SET);
				  fread(&mapping,sizeof(unsigned int),1,fd);
				  printf("\nMapping address: %x\n",mapping);
					int nr_str;
					fseek(fd,(mapping+kernoff-KERN)+6*sizeof(unsigned int),SEEK_SET);
					fread(&nr_str,sizeof(int),1,fd);
					printf("Number of pages %d\n",nr_str);
					fseek(fd,(mapping+kernoff-KERN),SEEK_SET);
					fread(&page1,sizeof(unsigned int),1,fd);
					printf("Page desc addresses: %x ",page1);
					int licz2;
				  for(licz2=1;licz2<nr_str;licz2++){
				    fseek(fd,(page1+kernoff-KERN),SEEK_SET);
				    fread(&page1,sizeof(unsigned int),1,fd);
				    printf(" %x",page1);

				  }
				  printf("\n");

	printf("Address range: %x-%x (vma: %x), file (%s) %x, dirent %x, inode %x, mapping %x \n",start,stop,vma_str,name,file,dir,inode,mapping);
	printf("==============Memory region================\n");
	}
	fseek(fd,(vma_str+kernoff-KERN)+3*sizeof(unsigned int),SEEK_SET);
        fread(&vma_str,sizeof(unsigned int),1,fd);
	}	

	break;
	//---------------------------------
	case '?': 
	print_usage (stderr, 1);
	case -1: 
	break;
	default: 
	abort ();
	}
}
while (next_option != -1);

	return 0;
}
